Lua_TreasureActivityItem = class("Lua_TreasureActivityItem", Lua_ListCell);
function Lua_TreasureActivityItem:ctor(p)
	self:superCall("ctor", p, "TreasureActivityItem_skin");
end

function Lua_TreasureActivityItem:buildShowItem()
	self:superCall("buildShowItem");

	self.iconImg = UICreate.createUIAtlasImage(self.content, "", "", -126.5, -14.5, 0, 0);
	self.iconImg:setDepth(5);
	self.iconImg:setScale(0.9, 0.9, 0.9);

	self.gotoBtn:addClickFuntion(self, self.onGoToClick)
end

function Lua_TreasureActivityItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	self.itemLbl.text = data.content
	self.timesTxt.text = "[BFCCDF]".. data.eventNum .. "/" .. data.eventLimitNum

	self.iconImg.name = data.icon_name;
	self.iconImg:setAltas(data.atlas, data.icon_name);
end

function Lua_TreasureActivityItem:onGoToClick()
    if not self._data.winName then
        return;
    elseif DataCenter.funcOpenData:isOpened(self._data.open_id) == false then
        local cfg = getConfig({"func_open", self._data.open_id});
        if cfg and cfg.advance_message then
            OperateAlert.show(cfg.advance_message);
        end
        return;
	else
		if self._data.winIndex == -1 then
			Lua_WindowUtil.openWin(self._data.winName)
		elseif self._data.winIndex == 0 then
			local copyVo = DataCenter.copyData.copyDic;
			Lua_WindowUtil.openWin(self._data.winName, nil, copyVo[self._data.itemId]);
		elseif self._data.winIndex == -2 then
			local tlist = DataCenter.taskData:getListByType(Lua_TaskDefine.ROUTINE);
			if tlist and tlist:getSize() > 0 then
				Lua_WindowUtil.openWin(self._data.winName, WinParam.ACTION_OPEN, tlist[1]);
			else
				OperateAlert.show(LanUtil.getValue(121919));
				return;
			end
		elseif self._data.winIndex == -3 then
			Lua_ProxyManager.getProxy("Lua_YunBiaoProxy"):goYunBiao()
		else
			Lua_WindowUtil.openWin(self._data.winName, WinParam.ACTION_OPEN, self._data.winIndex);
		end

		if self._data.winName ~= "Lua_TreasureActivityWindow" then
			Lua_WindowUtil.openWin("Lua_TreasureActivityWindow", WinParam.ACTION_CLOSE);
		end
	end
end

function Lua_TreasureActivityItem:dispose()
	if self.iconImg ~= nil then
		self.iconImg:dispose();
		self.iconImg = nil;
	end
	self._data = nil;

	self:superCall("dispose");
end