-- 藏宝之地
checkRequire("Lua_TreasureActivityItem");
checkRequire("Lua_TreasureInfoPanel");
Lua_TreasureActivityWindow = class("Lua_TreasureActivityWindow", Lua_Window);
function Lua_TreasureActivityWindow:ctor(p)
	self:superCall("ctor");

	self.windowName = "Lua_TreasureActivityWindow";
	self.skinName = "TreasureActivity_skin";
end

function Lua_TreasureActivityWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.timeTxt.text = "";

	self.avo = DataCenter.OperationalActivitiesData:getActivitiesByType(Lua_OperationalActivitiesData.ACT_TREASURE);
	if not self.avo then
		self:hide();
		return;
	end

	-- 宝箱拖拽
	self.treasure_dragContainer = Lua_DragContainer.new(self.content, 2, Vector4(-197, -13, 544, 522));
	self.treasure_dragContainer:setLocation(0, 0, 0);
	self.treasure_InfoPanel = Lua_TreasureInfoPanel.new(self.treasure_dragContainer);

	self.kuang:setParent(self.treasure_dragContainer.mainContent.transform);
	self.nameBg:setParent(self.treasure_dragContainer.mainContent.transform);
	self.nameTxt:setParent(self.treasure_dragContainer.mainContent.transform);

	self.treasure_dragList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 368, 426));
	self.treasure_dragList:setListCell(Lua_TreasureActivityItem, 145, 368, 1);
	self.treasure_dragList:setLocation(270, -34, 0);

	self.tipsIcon:addClickFuntion(self, self.onHelpClick);
	self.lastBtn:addClickFuntion(self, self.onLastClick);
	self.nextBtn:addClickFuntion(self, self.onNextClick);

	self:addLuaEvent("UPDATE_TREASUREACTIVITY_DATA", self, self.onUpdatePanelInfo);
	self:addLuaEvent("UPDATE_ONEPANEL_DATA", self, self.onUpdatePanelDataInfo); -- 更新面板信息事件监听
	sendMsg(10404105);
	Lua_ProxyManager.getProxy("Lua_TreasureActivityProxy"):sInitMsg();
	DataCenter.OperationalActivitiesData:sGetOperationalActivities(self.avo.act_index, Lua_OperationalActivitiesData.ACT_TREASURE);
end

function Lua_TreasureActivityWindow:onUpdatePanelInfo()
	if DataCenter.treasureActivityData.stage_index then
		self.curIndex = DataCenter.treasureActivityData.stage_index;
	end

	self.treasure_dragList:setLuaArrayData(DataCenter.treasureActivityData.treasureEventArr, false)

	if DataCenter.treasureActivityData.curTreasureBoxArr then
		self.treasure_InfoPanel:setData(DataCenter.treasureActivityData.curTreasureBoxArr);
	end

	local totalTime = DataCenter.treasureActivityData.stop_tick;
	local leftTime = totalTime - tonumber(tostring(GlobalVar.cur_tick));
	self.timeTxt.text = LanUtil.formateStr(LanUtil.getValue(127101), TimeTransform.getInstance():transSeconds1(leftTime, true));
	self:startTimer();
	self:onTreasureTimeDown();

	self.nameTxt.text = LanUtil.formateStr(LanUtil.getValue(127103), tostring(self.curIndex));
	self.treasureTxt.text = LanUtil.formateStr(LanUtil.getValue(127102), tostring(DataCenter.treasureActivityData.total_treasure_roll));

	self.lastBtn:setEnable(self.curIndex ~= 1);
	self.nextBtn:setEnable(self.curIndex ~= DataCenter.treasureActivityData.treasureFloors)
end

function Lua_TreasureActivityWindow:startTimer()
	if self.countDown ~= true then
		self.countDown = true;
		Lua_CommonUtil.addTimer("Lua_TreasureActivityWindow", 1, self, self.onTreasureTimeDown);
	end
end

function Lua_TreasureActivityWindow:onTreasureTimeDown()
	local totalTime = DataCenter.treasureActivityData.stop_tick;
	local leftTime = totalTime - tonumber(tostring(GlobalVar.cur_tick));
	self.timeTxt.text = LanUtil.formateStr(LanUtil.getValue(127101), TimeTransform.getInstance():transSeconds1(leftTime, true));
	if leftTime <= 0 then
		self:endTimer();
	end
end

function Lua_TreasureActivityWindow:endTimer()
	if self.countDown == true then
		self.countDown = false;
		Lua_CommonUtil.removeTimer(self, self.onTreasureTimeDown);
	end
end

function Lua_TreasureActivityWindow:onUpdatePanelDataInfo(msg)
	local act_detail = msg.act_detail;
	if act_detail == self.avo.act_index and act_detail.first_type == Lua_OperationalActivitiesData.ACT_TREASURE then
		self:onUpdatePanelInfo();
	end
end

function Lua_TreasureActivityWindow:onHelpClick()
	Lua_WindowUtil.openWin("Lua_RuleTipWindow", WinParam.ACTION_AUTO, DataCenter.treasureActivityData.tipsContent);
end

function Lua_TreasureActivityWindow:onLastClick()
	self.curIndex = self.curIndex - 1;
	if self.curIndex == 0 then
		self.curIndex = 1;
	end

	for i = 1, 5 do
		self.treasure_InfoPanel.boxList[i].redDot:setEnable(false);
	end
	DataCenter.treasureActivityData:changeStage(self.curIndex);
end

function Lua_TreasureActivityWindow:onNextClick()
	self.curIndex = self.curIndex + 1;
	if DataCenter.treasureActivityData.treasureFloors ~= nil then
		if self.curIndex >= DataCenter.treasureActivityData.treasureFloors then
			self.curIndex = DataCenter.treasureActivityData.treasureFloors;
		end
	end

	for i = 1, 5 do
		self.treasure_InfoPanel.boxList[i].redDot:setEnable(false);
	end
	DataCenter.treasureActivityData:changeStage(self.curIndex);
end

function Lua_TreasureActivityWindow:dispose()
	if self.treasure_dragContainer then
		self.treasure_dragContainer:dispose();
		self.treasure_dragContainer = nil;
	end
	if self.treasure_dragList then
		self.treasure_dragList:dispose();
		self.treasure_dragList = nil;
	end
	if self.treasure_InfoPanel ~= nil then
		self.treasure_InfoPanel:dispose();
		self.treasure_InfoPanel = nil;
	end
	self:endTimer();

	self:superCall("dispose");
end