Lua_TreasureBoxItem = class("Lua_TreasureBoxItem", Lua_DisplayObject)
function Lua_TreasureBoxItem:ctor(p)
	self:superCall("ctor", p, "TreasureBoxItem_skin");
end

function Lua_TreasureBoxItem:dispose()
	self:superCall("dispose");
end

function Lua_TreasureBoxItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemReward1 = Lua_ToolImage.new(self.content);
	self.itemReward1:setDepth(6);
	self.itemReward1:setScale(0.6, 0.6)
	self.itemReward1:setLocation(-40.5, 27.5);

	self.itemReward2 = Lua_ToolImage.new(self.content);
	self.itemReward2:setDepth(6);
	self.itemReward2:setScale(0.6, 0.6)
	self.itemReward2:setLocation(36.5, 27.5);

	self.redDot = UICreate.createUIAtlasImage(self.boxBg.mainContent, "common_atlas_1", "ui_common_hongdian", 38, 10, 0, 0);
	self.redDot.name = "redDot";
	self.redDot:setDepth(10);

	self.boxBg:addClickFuntion(self, self.onBoxClick);
end

function Lua_TreasureBoxItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	self.itemReward1.data = data.itemVoArr[1];
	self.itemReward2.data = data.itemVoArr[2];
	if DataCenter.treasureActivityData.isLastFinish == true then
		self.des.text = LanUtil.formateStr(LanUtil.getValue(127107), tostring(data.rollNumber));
	else
		self.des.text = LanUtil.getValue(127108);
	end
	self.boxBg:setAltas("treasureActivity_atlas", data.iconName);

	self.redDot:setEnable(data.draw_flag == 0);
	if data.draw_flag == 0 then
		self.startTime = getTime();
	    self.endTime = self.startTime + 0.5;
	    self.interval = 2.5;
		self:addTimer("boxAnima", 0.01, self, self.boxAnima);
	else
		Lua_CommonUtil.removeTimer(self, self.boxAnima);
		self.boxBg:setRot(0, 0, 0);
	end
end

function Lua_TreasureBoxItem:boxAnima()
	if getTime() <= self.endTime then
		local distance = math.sin((getTime() - self.startTime) * 8 * math.pi);
		self.boxBg:setRot(0, 0, distance * 5);
	elseif getTime() > self.endTime and getTime() < self.startTime + self.interval then
		self.boxBg:setRot(0, 0, 0);
	elseif getTime() > self.startTime + self.interval then
		self.startTime = getTime();
		self.endTime = self.startTime + 0.5;
	end
end

function Lua_TreasureBoxItem:onBoxClick(go)
	if self._data.draw_flag == 0 then
		Lua_WindowUtil.openWin("Lua_TreasureTipsWindow", WinParam.ACTION_OPEN, {owner = self,
			subFun = self.onSubCallBack, rewardArr = self._data.itemVoArr});
	elseif self._data.draw_flag == 1 then
		OperateAlert.show(LanUtil.getValue(127104));
	else
		OperateAlert.show(LanUtil.getValue(127105));
	end
end

function Lua_TreasureBoxItem:onSubCallBack(item_id)
	local stage_index = self._data.stage_index - 1;
	local reward_index = self._data.reward_index;
	if item_id == nil or item_id == 0 then
		OperateAlert.show(LanUtil.getValue(127106));
		return;
	else
		Lua_ProxyManager.getProxy("Lua_TreasureActivityProxy"):sGetRewardMsg(stage_index, reward_index, item_id);
	end
end

function Lua_TreasureBoxItem:dispose()
	if self.itemReward1 ~= nil then
		self.itemReward1:dispose();
		self.itemReward1 = nil;
	end
	if self.itemReward2 ~= nil then
		self.itemReward2:dispose();
		self.itemReward2 = nil;
	end
	if self.redDot ~= nil then
		self.redDot:dispose();
		self.redDot = nil;
	end
	self._data = nil;
    Lua_CommonUtil.removeTimer(self, self.boxAnima);
	self:superCall("dispose");
end