checkRequire("Lua_TreasureBoxItem")
Lua_TreasureInfoPanel = class("Lua_TreasureInfoPanel", Lua_DragContainerItem);
function Lua_TreasureInfoPanel:ctor(dragContainer)
	self:superCall("ctor", dragContainer.sub);

	dragContainer:addSubContainer(self, true);
	self.dragContainer = dragContainer;
end

function Lua_TreasureInfoPanel:buildShowItem()
	self:superCall("buildShowItem");
    
	self.mapImage = UICreate.createImage(self.content, "/images/treasureActivity/ui_cbzd_d7.png", 6, -8.5, 950, 530);
	self.mapImage.pivot = UIWidget.Pivot.Center;
	self.mapImage:setDepth(-1);

	self.boxList = {};
	self.lineList = {};
	-- posX 横坐标， posY 纵坐标， rotateZ 旋转角度，x 长度, y 高度
	self.linePosList = {
		[1] = {posX = -290, posY = -115, rot = 37.5, x = 192, y = 18},
		[2] = {posX = -126, posY = -134, rot = -40.5, x = 242, y = 18},
		[3] = {posX = 55, posY = -148, rot = 33.5, x = 227, y = 18},
		[4] = {posX = 250, posY = -124.5, rot = -21.5, x = 222, y = 18}};

	self.posList = {
		[1] = {posX = -364.5, posY = -9.5},
		[2] = {posX = -215, posY = 103.5},
		[3] = {posX = -38.5, posY = -48},
		[4] = {posX = 146.5, posY = 75},
		[5] = {posX = 349.5, posY = -3}};
end

function Lua_TreasureInfoPanel:setData(data)
	self.data = data
	if data == nil then
		return;
	end

	-- 生成宝箱
	local box;
	for i = 1, self.data.boxCount do
		local box = self.boxList[i];
		if box == nil then
			box = Lua_TreasureBoxItem.new(self.content);
			box.boxBg.name = "boxBg"..self.data.stage_index;
			box:setLocation(self.posList[i].posX, self.posList[i].posY);
			self.boxList[i] = box;
		end
		box:setData(self.data.boxArr[i]);
	end

	local tempLen = #self.boxList
	for i = self.data.boxCount, tempLen, -1 do
		if self.boxList[i] ~= nil and i > self.data.boxCount then
			self.boxList[i]:dispose();
			self.boxList[i] = nil;
		end
	end

	-- 生成线
	local lineType;
	local line;
	for i = 1, self.data.boxCount - 1 do
		lineType = self.data.boxArr[i].draw_flag == 2 and "ui_cbzd_x1" or "ui_cbzd_x";

		line = self.lineList[i];
		if line == nil then
			line = UICreate.createUIAtlasImage(self.content, "", "", self.linePosList[i].posX, self.linePosList[i].posY, 0, 0);
			line.type = UIBasicSprite.Type.Sliced;
			line:setDepth(1);
			line:setRot(0, 0,self.linePosList[i].rot)
			line:SetDimensions(self.linePosList[i].x, self.linePosList[i].y);
			self.lineList[i] = line;
		end
		self.lineList[i]:setAltas("treasureActivity_atlas", lineType);
	end

	self.dragContainer:updateChildPos();
	self:checkOutBound();
end

function Lua_TreasureInfoPanel:checkOutBound()
	if self.dragContainer.sub.transform.localPosition.x >= 0 then
		self.dragContainer.sub.transform.localPosition = Vector3(0, 0, 0);
	end

	if self.dragContainer.sub.transform.localPosition.x <= -406 then
		self.dragContainer.sub.transform.localPosition = Vector3(-406, 0, 0);
	end

	local subPosX = self.dragContainer.sub.transform.localPosition.x;
	for i = 1, 5 do
		if self.posList[i].posX + subPosX - 40.5 <= -428 or self.posList[i].posX + subPosX - 40.5 >= 46 then
			if self.boxList[i].itemReward1.roundEff ~= nil then
				self.boxList[i].itemReward1:showRoundEff(false)
			end
		else
			if self.boxList[i].itemReward1.roundEff == nil then
				if self.boxList[i].itemReward1.data.showeffect then
					self.boxList[i].itemReward1:showRoundEff(true);
				end
			end
		end

		if self.posList[i].posX + subPosX + 36.5 <= -428 or self.posList[i].posX + subPosX + 36.5 >= 46 then
			if self.boxList[i].itemReward2.roundEff ~= nil then
				self.boxList[i].itemReward2:showRoundEff(false)
			end
		else
			if self.boxList[i].itemReward2.data.showeffect then
				if self.boxList[i].itemReward2.roundEff == nil then
					self.boxList[i].itemReward2:showRoundEff(true)
				end
			end
		end
	end
end

function Lua_TreasureInfoPanel:getWidth()
	return self.mapImage.width;
end

function Lua_TreasureInfoPanel:getHeight()
	return self.mapImage.height;
end

function Lua_TreasureInfoPanel:dispose()
	if self.boxList ~= nil then
		for i = 1, #self.boxList do
			self.boxList[i]:dispose();
		end
	end
	self:superCall("dispose");
end