Lua_TreasureTipsWindow = class("Lua_TreasureTipsWindow", Lua_ThirdSizeWindow);
function Lua_TreasureTipsWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_TreasureTipsWindow";
	self.skinName = "TreasureTipsWindow_skin";
	self.w = 458;
	self.h = 290;
	self.titleText = LanUtil.getValue(127106);
end

function Lua_TreasureTipsWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.winBg:setLocation(0, 55);
	self.btnClose:setLocation(197, 174);
	self.titleBg:setLocation(0, 172);
	self.titleNameText:setLocation(0, 171);
	self.titleNameText:SetDimensions(210, 30);

	self.subBtn:addClickFuntion(self, self.onSubClick);
end

function Lua_TreasureTipsWindow:showWin(param)
	self.data = param;
	self.isSelected = false;
	self:showRewards();
	self.selectedId = 0;
end 

function Lua_TreasureTipsWindow:showRewards()
	if self.data.rewardArr ~= nil then
		self.rewardArr = Array();

		local len = self.data.rewardArr:getSize()
		for i = 1, len do
			local item = Lua_ToolImage.new(self.content);
			item.content.name = i;
			item.data = self.data.rewardArr[i]
			item:setDepth(3);
			item:removeFun(false);
			item:setLocation(-73 +(i - 1) * 145, 67, 0);
			item.item_bg:addClickFuntion(self, self.onIconClick)

			local tickImg = UICreate.createUIAtlasImage(item.item_bg.mainContent, "common_atlas_1", "ui_common_xz", 0, 0, 56, 44);
			tickImg:setDepth(6);
			tickImg:setEnable(false);

			local selected_mask = UICreate.createUIAtlasImage(item.item_bg.mainContent, "common_atlas_1", "ui_common_black_50", 0, 0, 75, 77);
			selected_mask:setDepth(5);
			selected_mask:setEnable(false);

			self.rewardArr:add({item = item, tickImg = tickImg, selected_mask = selected_mask})
		end
	end
end

function Lua_TreasureTipsWindow:onIconClick(go)
	local index = tonumber(go.transform.parent.name);
	local len = self.rewardArr:getSize();
	for i = 1, len do
		if i == index then
			self.rewardArr[i].tickImg:setEnable(true);
			self.rewardArr[i].selected_mask:setEnable(true);
			self.selectedId = self.rewardArr[i].item.data.id
		else
			self.rewardArr[i].tickImg:setEnable(false);
			self.rewardArr[i].selected_mask:setEnable(false);
		end
	end
end

function Lua_TreasureTipsWindow:onSubClick(go)
	self:exeSub();
	self:hide();
end

function Lua_TreasureTipsWindow:exeSub()
	if self.data ~= nil and self.data.subFun ~= nil then
		if DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getLeftSize() <= 0 then
			OperateAlert.show(LanUtil.getValue(121212));
		else
			if self.data.boxVo ~= nil then
				self.data.subFun(self.data.owner, self.selectedId, self.data.boxVo);
			else
				self.data.subFun(self.data.owner, self.selectedId);
			end
		end
	end
end

function Lua_TreasureTipsWindow:dispose()
	if self.rewardArr ~= nil then
		self.rewardArr:dispose();
		self.rewardArr:clear();
		self.rewardArr = nil;
	end
	self.selectedId = 0;

	self:superCall("dispose");
end